local E, L, V, P, G, _ = unpack(ElvUI); --Import: Engine, Locales, PrivateDB, ProfileDB, GlobalDB
local CCW = E:NewModule('CustomChannelWarning', 'AceEvent-3.0')
local CH = E:GetModule('Chat')
local LSM = LibStub("LibSharedMedia-3.0")

-- Default Options
P['chat']['customchannelSound'] = 'Whisper Alert'

-- Function which monitors custom channels and plays sound
function CCW:MonitorChannels(event, _, author, _, _, _, _, chanID, ...)
	if author == UnitName("player") then return end -- Don't play sound if the message is from yourself
	if event == "CHAT_MSG_CHANNEL" and chanID == 0 and E.db.chat.customchannelSound ~= "None" and not CH.SoundPlayed then
		PlaySoundFile(LSM:Fetch("sound", E.db.chat.customchannelSound), "Master")
		CH.SoundPlayed = true
		CH.SoundTimer = CH:ScheduleTimer('ThrottleSound', 1)
	end
end

-- Stuff to do when addon is initialized
function CCW:Initialize()
	self:RegisterEvent('CHAT_MSG_CHANNEL', 'MonitorChannels')
end

-- Insert options into ElvUI
E.Options.args.chat.args.general.args.customchannelSound = {
	order = 50,
	type = 'select', dialogControl = 'LSM30_Sound',
	name = L["Custom Channel Alert"],
	disabled = function() return not E.db.chat.customchannelSound end,
	values = AceGUIWidgetLSMlists.sound,
	set = function(info, value) E.db.chat.customchannelSound = value; end,
},

E:RegisterModule(CCW:GetName())